local BOSS_PINCH_MUSICID = "ADVBS2"

local function AdvanceSystem(mobj)
	for player in players.iterate
		if player.mo and player.mo.valid and player.mo.skin == "advancesonic"
			if not player.powers[pw_super]
			and player.playerstate == PST_LIVE
				if mobj.health <= 3 and mobj.music_changed == nil then
					S_ChangeMusic(BOSS_PINCH_MUSICID, player, true)
					mobj.music_changed = true
				end
				if mobj.type == MT_CYBRAKDEMON then
					BOSS_PINCH_MUSICID = "ADVBS5"
				elseif mobj.type == MT_METALSONIC_BATTLE then
					BOSS_PINCH_MUSICID = "ADVBS3"
				else
					BOSS_PINCH_MUSICID = "ADVBS2"
				end
			else
				if S_MusicName() == "ADVBS1"
				or S_MusicName() == "ADVBS2"
				or S_MusicName() == "ADVBS3"
				or S_MusicName() == "ADVBS4"
				or S_MusicName() == "ADVBS5"
				or S_MusicName() == "VSMETL"
				or S_MusicName() == "VSFANG"
				or S_MusicName() == "VSBRAK"
				or S_MusicName() == "VSBOSS"
					COM_BufInsertText(player, "tunes -default")
					P_RestoreMusic(player)
					mobj.music_changed = false
				end
			end
		end
	end
end

addHook("MobjThinker", AdvanceSystem, MT_EGGMOBILE)
addHook("MobjThinker", AdvanceSystem, MT_EGGMOBILE2)
addHook("MobjThinker", AdvanceSystem, MT_EGGMOBILE3)
addHook("MobjThinker", AdvanceSystem, MT_EGGMOBILE4)
addHook("MobjThinker", AdvanceSystem, MT_FANG)
addHook("MobjThinker", AdvanceSystem, MT_METALSONIC_BATTLE)
addHook("MobjThinker", AdvanceSystem, MT_CYBRAKDEMON)