local ADVANCETRICK = {sfx_none, sfx_asyeah, sfx_none}

local ADVANCEDAMAGE = {sfx_none, sfx_ha1, sfx_none, sfx_ha2, sfx_none, sfx_ha3, sfx_none, sfx_ha4, sfx_none}

local BattleFuncSet = false

addHook("ThinkFrame",function()
	if (BattleFuncSet) or not(CBW_Battle and CBW_Battle.SkinVars) then return end
		BattleFuncSet = true
		local AdvancePriority = function(player)
			if player.homing
				CBW_Battle.SetPriority(player,1,2,nil,1,2,"Advance Homing")
			end
			if player.mo.advanceground
				CBW_Battle.SetPriority(player,1,0,"knuckles_glide",2,1,"Advance Ground")
			end
			if player.bound == 1
				CBW_Battle.SetPriority(player,1,0,"knuckles_glide",2,1,"Bound Attack")
			end
			if player.mo.state == S_ADVANCETWIN_BATTLE1
			or player.mo.state == S_ADVANCETWIN_BATTLE2
			or player.mo.state == S_ADVANCETWIN_BATTLE3
			or player.mo.state == S_ADVANCETWIN_BATTLE4
			or player.mo.state == S_ADVANCETWIN_BATTLE5
			or player.mo.state == S_ADVANCETWIN_BATTLE6
				CBW_Battle.SetPriority(player,1,0,"knuckles_glide",2,1,"Advance Twinspin")
			end
			if player.mo.state == S_ADVANCE_KICKDAMAGE1
			or player.mo.state == S_ADVANCE_KICKDAMAGE2
			or player.mo.state == S_ADVANCE_KICKDAMAGE3
			or player.mo.state == S_ADVANCE_KICKDAMAGE4
			or player.mo.state == S_ADVANCE_KICKDAMAGE5
			or player.mo.state == S_ADVANCE_KICKDAMAGE6
			or player.mo.state == S_ADVANCE_KICKDAMAGE7
			or player.mo.state == S_ADVANCE_KICKDAMAGE8
				CBW_Battle.SetPriority(player,1,0,"knuckles_glide",2,1,"Advance Kick")
			end
			if player.mo.state == S_PLAY_ADVANCE_UPPERKICK1
			or player.mo.state == S_PLAY_ADVANCE_UPPERKICK2
			or player.mo.state == S_PLAY_ADVANCE_UPPERKICK3
			or player.mo.state == S_PLAY_ADVANCE_UPPERKICK4
			or player.mo.state == S_PLAY_ADVANCE_UPPERKICK5
			or player.mo.state == S_PLAY_ADVANCE_UPPERKICK6
			or player.mo.state == S_PLAY_ADVANCE_UPPERKICK7
			or player.mo.state == S_PLAY_ADVANCE_UPPERKICK8
				CBW_Battle.SetPriority(player,1,0,"knuckles_glide",2,1,"Upper Kick")
			end
		end
		local AdvanceBattle = function(mo,doaction,pressedaction)
		local player = mo.player
		if mo.state == S_ADVANCETRICK1 or mo.state == S_ADVANCETRICK2 or mo.state == S_ADVANCETRICK3
		or mo.state == S_ADVANCETHOK or mo.state_trickadventure or mo.advanceground or mo.advanceslide
		or mo.state == S_ADVANCETWIN_BATTLE1 or mo.state == S_ADVANCETWIN_BATTLE2 or mo.state == S_ADVANCETWIN_BATTLE3
		or mo.state == S_ADVANCETWIN_BATTLE4 or mo.state == S_ADVANCETWIN_BATTLE5 or mo.state == S_ADVANCETWIN_BATTLE6
		or mo.state == S_ADVANCE_KICKDAMAGE1 or mo.state == S_ADVANCE_KICKDAMAGE2 or mo.state == S_ADVANCE_KICKDAMAGE3
		or mo.state == S_ADVANCE_KICKDAMAGE4 or mo.state == S_ADVANCE_KICKDAMAGE5 or mo.state == S_ADVANCE_KICKDAMAGE6
		or mo.state == S_ADVANCE_KICKDAMAGE7 or mo.state == S_ADVANCE_KICKDAMAGE8
		or mo.state == S_PLAY_ADVANCE_UPPERKICK1 or mo.state == S_PLAY_ADVANCE_UPPERKICK2 or mo.state == S_PLAY_ADVANCE_UPPERKICK3
		or mo.state == S_PLAY_ADVANCE_UPPERKICK4 or mo.state == S_PLAY_ADVANCE_UPPERKICK5 or mo.state == S_PLAY_ADVANCE_UPPERKICK6
		or mo.state == S_PLAY_ADVANCE_UPPERKICK7 or mo.state == S_PLAY_ADVANCE_UPPERKICK8 or mo.player.homing
			player.canguard = false
		end
		if P_IsObjectOnGround(mo)
			if player.dashspeed > (player.maxdash/5*3) then
				player.actiontext = "Spin Wave"
			elseif (player.pflags & PF_SPINNING)
			and player.speed > 10*FRACUNIT
			and player.mo.state == S_PLAY_ROLL
				player.actiontext = "Advance Kick"
			elseif player.mo.state == S_ADVANCE_KICKDAMAGE1
			or player.mo.state == S_ADVANCE_KICKDAMAGE2
			or player.mo.state == S_ADVANCE_KICKDAMAGE3
			or player.mo.state == S_ADVANCE_KICKDAMAGE4
			or player.mo.state == S_ADVANCE_KICKDAMAGE5
			or player.mo.state == S_ADVANCE_KICKDAMAGE6
			or player.mo.state == S_ADVANCE_KICKDAMAGE7
			or player.mo.state == S_ADVANCE_KICKDAMAGE8
				player.actiontext = "Advance Upper Kick"
			else 
				player.actiontext = "Slide"
			end
		else
			if player.bound == 1
				player.actiontext = "Advance Twin"
			else
				player.actiontext = "Ground Pound"
			end
		end
		player.actionrings = 10
		if player.actionstate != 0
			player.canguard = false
		end
		if player.mo.state == S_ADVANCE_KICKDAMAGE8
			CBW_Battle.ApplyCooldown(player,2*TICRATE)
		end
		if player.actionstate == 0
		and not player.homing
		and not player.mo.advanceslide
		and not player.mo.advanceground
			if doaction == 1
				CBW_Battle.PayRings(player)
				S_StartSound(player.mo, ADVANCETRICK[P_RandomRange(1, #ADVANCETRICK)])
				if P_IsObjectOnGround(mo)
					if player.dashspeed > (player.maxdash/5*3) then
						local thrust = FixedMul(22*FRACUNIT,player.jumpfactor)
						P_SetObjectMomZ(mo,10*FRACUNIT,true) //Inherit platform momentum
						P_Thrust(mo,(mo.angle-ANGLE_180),thrust/2)// recoil back
						player.pflags = (player.pflags|PF_JUMPED|PF_THOKKED)&~(PF_STARTJUMP|PF_NOJUMPDAMAGE|PF_GLIDING|PF_BOUNCING|PF_SPINNING)
						mo.state = S_PLAY_ROLL
						player.secondjump = 0
						player.canguard = false
						player.powers[pw_nocontrol] = 2
						S_StartSound(player.mo, sfx_advtk1)
						 local spinwave = P_SpawnMobjFromMobj(player.mo, FixedMul(player.mo.radius, cos(player.mo.angle)),
						 FixedMul(player.mo.radius, sin(player.mo.angle)), 0, MT_ADVANCESPINWAVE)
							spinwave.target = player.mo
							spinwave.spawntime = 0
							local spinwave_speed = player.dashspeed+1*FRACUNIT
							spinwave.startingspeed = spinwave_speed
							 spinwave.angle = player.mo.angle
							 spinwave.color = SKINCOLOR_SKY
							 spinwave.blendmode = AST_ADD
							 if G_GametypeHasTeams() then
									spinwave.color = player.skincolor
								end
						CBW_Battle.ApplyCooldown(player,4*TICRATE)
					elseif (player.pflags & PF_SPINNING)
					and player.speed > 10*FRACUNIT
					and player.mo.state == S_PLAY_ROLL
						S_StartSound(player.mo, sfx_advtk1)
						S_StartSound(player.mo, ADVANCEDAMAGE[P_RandomRange(1, #ADVANCEDAMAGE)])
						player.mo.state = S_ADVANCE_KICKDAMAGE1
						player.pflags = $1 & ~PF_SPINNING
						player.pflags = $1 & ~PF_THOKKED
						player.pflags = $1 & ~PF_JUMPED
						player.pflags = $1 & ~PF_SPINDOWN
						player.pflags = $1 & ~PF_STARTDASH
						//CBW_Battle.ApplyCooldown(player,1*TICRATE)
					elseif player.mo.state == S_ADVANCE_KICKDAMAGE1
					or player.mo.state == S_ADVANCE_KICKDAMAGE2
					or player.mo.state == S_ADVANCE_KICKDAMAGE3
					or player.mo.state == S_ADVANCE_KICKDAMAGE4
					or player.mo.state == S_ADVANCE_KICKDAMAGE5
					or player.mo.state == S_ADVANCE_KICKDAMAGE6
					or player.mo.state == S_ADVANCE_KICKDAMAGE7
					or player.mo.state == S_ADVANCE_KICKDAMAGE8
						local thrust = FixedMul(22*FRACUNIT,player.jumpfactor)
						P_SetObjectMomZ(mo,6*FRACUNIT,true) //Inherit platform momentum
						P_Thrust(mo,(mo.angle-ANGLE_180),thrust/2)// recoil back
						player.pflags = (player.pflags|PF_JUMPED|PF_THOKKED)&~(PF_STARTJUMP|PF_NOJUMPDAMAGE|PF_GLIDING|PF_BOUNCING|PF_SPINNING)
						mo.state = S_PLAY_ADVANCE_UPPERKICK1
						S_StartSound(player.mo, sfx_advtk1)
						S_StartSound(player.mo, ADVANCEDAMAGE[P_RandomRange(1, #ADVANCEDAMAGE)])
						CBW_Battle.ApplyCooldown(player,2*TICRATE)
					else
						S_StartSound(player.mo, sfx_advtk1)
						player.mo.advanceslide = TICRATE
						CBW_Battle.ApplyCooldown(player,4*TICRATE)
					end
				else
					player.pflags = (player.pflags|PF_JUMPED|PF_THOKKED)&~(PF_STARTJUMP|PF_NOJUMPDAMAGE|PF_GLIDING|PF_BOUNCING|PF_SPINNING)
					if player.bound == 1
						S_StartSound(player.mo, sfx_advtk1)
						S_StartSound(player.mo, ADVANCEDAMAGE[P_RandomRange(1, #ADVANCEDAMAGE)])
						player.mo.state = S_ADVANCETWIN_BATTLE1
						player.bound = 0
						CBW_Battle.ApplyCooldown(player,4*TICRATE)
					else
						S_StartSound(player.mo, sfx_thok)
						player.mo.advanceground = 5
						P_Thrust(mo,mo.angle,FixedMul(22*FRACUNIT,player.jumpfactor))
						CBW_Battle.ApplyCooldown(player,4*TICRATE)
						if (player.mo.eflags & MFE_UNDERWATER)
							P_SetObjectMomZ(player.mo, 25*FRACUNIT/2)
						else
							P_SetObjectMomZ(player.mo, 25*FRACUNIT)
						end
					end
				end
			end
		end
	end
	CBW_Battle.SkinVars["advancesonic"] = {
		weight = 100,
		special = AdvanceBattle,
		func_priority_ext = AdvancePriority
	}
	print("Advance Sonic Battle Mode support has been added!")
end)