addHook("ThinkFrame", do
	for player in players.iterate
		local s = player.mo
		if player.mo and (player.mo.skin == "advancesonic")
			if (player.pflags & PF_JUMPED)
			and not (player.pflags & PF_THOKKED)
			and not P_IsObjectOnGround(player.mo)
			and player.playerstate == PST_LIVE
			and player.mo.state == S_PLAY_JUMP
				if (CBW_Battle)
					player.mo.state = S_PLAY_ADVANCE_SPRING
					player.pflags = $1|PF_NOJUMPDAMAGE
				end
			end
			if (CBW_Battle)
				player.normalspeed = 18*FRACUNIT
			end
			if not (player.mo.advanceground)
				player.mo.advanceground = 0
			end
			if player.mo.advanceground > 0
				player.mo.advanceground = $1 - 1
			end
			if not (player.mo.advanceslide)
				player.mo.advanceslide = 0
			end
			if player.mo.advanceslide > 0
				player.mo.advanceslide = $1 -1
			end
			if player.mo.advanceslide > 1
			and player.playerstate == PST_LIVE
				player.mo.state = S_ADVANCESLIDE
				player.pflags = $1 & ~PF_JUMPED
				player.powers[pw_nocontrol] = 2
				player.drawangle = R_PointToAngle2(player.mo.x, player.mo.y, player.mo.x+player.mo.momx, player.mo.y+player.mo.momy)
				player.momangle2 = R_PointToAngle2(0,0,player.mo.momx,player.mo.momy)
				player.pflags = $|PF_DRILLING
				if (leveltime % 2) == 0
					AdvanceTrail(player, s, player.mo.color, 7, true)
				end
				if player.speed >= 15
					if player.powers[pw_sneakers]
						if FixedHypot(player.mo.momx, player.mo.momy) <= 42*player.mo.scale
							P_Thrust(player.mo, player.mo.angle, 42*player.mo.scale-FixedHypot(player.mo.momx, player.mo.momy))
						end
					else
						if FixedHypot(player.mo.momx, player.mo.momy) <= 22*player.mo.scale
							P_Thrust(player.mo, player.mo.angle, 22*player.mo.scale-FixedHypot(player.mo.momx, player.mo.momy))
						end
					end
				else
					if player.speed < 15
						if player.powers[pw_sneakers]
							if FixedHypot(player.mo.momx, player.mo.momy) <= 12*player.mo.scale
								P_Thrust(player.mo, player.mo.angle, 12*player.mo.scale-FixedHypot(player.mo.momx, player.mo.momy))
							end
						else
							if FixedHypot(player.mo.momx, player.mo.momy) <= 8*player.mo.scale
								P_Thrust(player.mo, player.mo.angle, 8*player.mo.scale-FixedHypot(player.mo.momx, player.mo.momy))
							end
						end
					end
				end
			else
				player.momangle2 = player.mo.angle
			end
			if player.mo.advanceground > 1
			and player.playerstate == PST_LIVE
			and not (P_IsObjectOnGround(player.mo))
				player.mo.state = S_PLAY_JUMP
				player.mo.spritexscale = FRACUNIT+FixedDiv(player.mo.momz/96,player.mo.scale)
				player.mo.spriteyscale = FRACUNIT-FixedDiv(player.mo.momz/96,player.mo.scale)
				player.mo.advanceground = 5
				player.mo.momx = 8*$/9
				player.mo.momy = 8*$/9
				P_SetObjectMomZ(player.mo, -1*FRACUNIT, true)
				if not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz > 0
				or player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz < 0
					P_SetObjectMomZ(player.mo, -2*FRACUNIT, true)
				end
				if not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz < 0
				or player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz > 0
					P_SetObjectMomZ(player.mo, -3*FRACUNIT, true)
				end
				if not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz < 10
				or player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz > 10
					P_SetObjectMomZ(player.mo, -4*FRACUNIT, true)
				end
				if not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz < 25
				or player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz > 25
					P_SetObjectMomZ(player.mo, -5*FRACUNIT, true)
				end
				if not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz < 45
				or player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz > 45
					P_SetObjectMomZ(player.mo, -6*FRACUNIT, true)
				end
				if (player.powers[pw_justsprung]
				or (player.mo.eflags & MFE_SPRUNG))
					player.mo.advanceground = 0
				end
				if (leveltime % 2) == 0
					AdvanceTrail(player, s, player.mo.color, 7, true)
				end
				if (player.mo.eflags & MFE_GOOWATER)
					player.mo.spritexscale = FRACUNIT
					player.mo.spriteyscale = FRACUNIT
					player.mo.advanceground = 0
				end
			end
			if player.mo.advanceground
			and (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
				player.mo.advanceground = 1
			end
			if player.mo.advanceground == 1
			and (P_IsObjectOnGround(player.mo))
			and player.playerstate == PST_LIVE
				//player.powers[pw_invulnerability] = 8
				player.mo.state = S_PLAY_SPRING
				player.pflags = $1 & ~(PF_JUMPED|PF_THOKKED)
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
				S_StartSound(player.mo, sfx_s3k5f)
				if not (player.mo.eflags & MFE_UNDERWATER)
					P_SetObjectMomZ(player.mo, 5*FRACUNIT)
				else
					P_SetObjectMomZ(player.mo, 3*FRACUNIT)
				end
				for i = 1, 30
					local blustdebris = P_SPMAngle(player.mo, MT_GROUNDPOUND, FixedAngle(12*FRACUNIT)*i, 0)
					if blustdebris and blustdebris.valid
						P_InstaThrust(blustdebris, player.mo.angle+(ANGLE_45*i), 35*FRACUNIT)
						blustdebris.colorized = true
						blustdebris.sttspeed = 2
						blustdebris.tics = 30
						blustdebris.color = player.skincolor
					end
				end
			end
			if P_PlayerInPain(player)
			or (CBW_Battle and (player.tumble != nil and player.tumble > 0)) //Tumble Fix
			or player.playerstate == PST_DEAD
			or player.mo.state == S_PLAY_PAIN
			or player.mo.sprite2 == SPR2_PAIN
				player.mo.state_trickadventure = 0
				player.mo.advanceground = 0
				player.mo.advanceslide = 0
				player.mo.spritexscale = FRACUNIT
				player.mo.spriteyscale = FRACUNIT
			end
		end
	end
end)

addHook("PlayerCanDamage", function(player)
	if (player.mo.skin == "advancesonic")
		if player.mo.advanceground or player.mo.advanceslide then
			return true
		end
    end
end)