if (VERSION == 202) and (SUBVERSION < 13)
	local function blackout(v)
		v.drawFill()
		v.drawString(160, 100, ("this mod requires version 2.2.13 or higher"),V_REDMAP, "center")
	end
	hud.add(blackout, "title")
	hud.add(blackout, "game")
	error("Your copy of 2.2 is obsolete and not compatible with this mod. Please update to version 2.2.11 or higher.", 0)
end

dofile("Lib/CustomHud.lua")
dofile("AdvanceMain.lua")
dofile("BattleMode/Objects.lua")
dofile("BattleMode/Function.lua")
dofile("BattleMode/Battle.lua")
dofile("AdvanceSuper.lua")
dofile("Music.lua")
dofile("BossFight.lua")
dofile("DamageBosses.lua")
dofile("Momentum.lua")
dofile("AdvanceHud.lua")